unit PlotMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, TeEngine, Series, ExtCtrls, TeeProcs, Chart,
  InferenceEngine;

type
  TForm1 = class(TForm)
    InferenceEngine1: TInferenceEngine;
    Chart1: TChart;
    Series1: TLineSeries;
    lbTypes: TListBox;
    lbSets: TListBox;
    procedure FormCreate(Sender: TObject);
    procedure lbTypesClick(Sender: TObject);
    procedure lbSetsClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
    FuzzyInterfaces;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
     lbTypes.Items.Assign(InferenceEngine1.DefinedTypes);
end;

procedure TForm1.lbTypesClick(Sender: TObject);
var
   i: Integer;
begin
     with Sender as TListBox do
     begin
          // Clear the chart series
          Series1.Clear;
          lbSets.Items.Clear;
          if ItemIndex = -1 then Exit;
          // fill in the fuzzy sets list box with the names of the fuzzy sets
          for i := 0 to InferenceEngine1.DefinedTypes[Items[ItemIndex]].FuzzyType.Count - 1 do
          begin
               lbSets.Items.Add(InferenceEngine1.DefinedTypes[Items[ItemIndex]].FuzzyType.FuzzySet[i].Name);
          end;
     end;
end;

procedure TForm1.lbSetsClick(Sender: TObject);
var
   i: Integer;
   FuzzySet: IFuzzySet;
begin
     with Sender as TListBox do
     begin
          Series1.Clear;
          if ItemIndex = -1 then Exit;
          // fill the teechart series with the fuzzy set values
          FuzzySet := InferenceEngine1.DefinedTypes[lbTypes.Items[lbTypes.ItemIndex]].FuzzyType.FuzzySet[ItemIndex];
          Series1.Title := FuzzySet.Name;
          if FuzzySet.Count > 0 then
             Series1.AddXY( FuzzySet.XMinimum, FuzzySet.YValues[0] );
          for i := 0 to FuzzySet.Count - 1 do
              Series1.AddXY( FuzzySet.XValues[i], FuzzySet.YValues[i] );
          if FuzzySet.Count > 0 then
             Series1.AddXY( FuzzySet.XMaximum, FuzzySet.YValues[FuzzySet.Count - 1]);
     end;
end;

end.
